Hooks:PostHook(TradeManager, "init", "RevivedParticleEffectSetup", function(self)
	self._revived_particle_effect = {}
end)

Hooks:PostHook(TradeManager, "sync_teammate_helped_hint", "RevivedParticleEffectRelease", function(self, helped_unit)
	local effect_id = World:effect_manager():spawn({
		effect = Idstring("effects/particles/revived_teammate"),
		position = helped_unit:position(),
		rotation = helped_unit:rotation()
	})
	
	if helped_unit == managers.player:player_unit() then
		return
	end
	
	self._revived_particle_effect[effect_id] = {
		unit = helped_unit,
		effect = effect_id,
		on_active = false
	}
end)

Hooks:PostHook(TradeManager, "update", "RevivedParticleEffectRelease", function(self)
	for _, data in pairs(self._revived_particle_effect) do
		local effect = data.effect

		if World:effect_manager():alive(effect) and alive(data.unit) then
			World:effect_manager():move(effect, data.unit:position())
			data.on_active = true
		else
			if data.on_active then
				self._revived_particle_effect[effect] = nil
			end
		end
	end
end)